## kmc 0.1-2

=== DESCRIPTION ===
Package: kmc
Version: 0.1-2
Title: Kaplan - Meier estimator with constraints for right censored
        data -- a recursive computational algorithm
Author: Yifan Yang <yifan.yang@uky.edu> , Mai Zhou<mai@ms.uky.edu>
Maintainer: Yifan Yang <yifan.yang@uky.edu>
Description: Calculate NPMLE with constraints for right censored data. This package give a recursive computational algorithm for the "constrained" Kaplan- Meier estimator. The constraint is assumed given in linear estimating equations or mean functions. We also illustrate how this leads to the empirical likelihood ratio test with right censored data. EM algorithm (emplik) is used to get the initial value. 
License: LGPL-3
Depends: R (>= 2.13.1), compiler, rootSolve, emplik, Rcpp
LinkingTo: Rcpp
Packaged: 2013-12-25 07:29:57 UTC; Yifan
NeedsCompilation: yes
Repository: CRAN
Date/Publication: 2013-12-25 09:15:26

## kmc 0.2-2

=== DESCRIPTION ===
Package: kmc
Version: 0.2-2
Title: Kaplan-Meier Estimator with Constraints for Right Censored Data
        -- a Recursive Computational Algorithm
Author: Yifan Yang [aut,cre], Mai Zhou [aut]
Maintainer: Yifan Yang <yifan.yang@uky.edu>
Description: Linearly constrained Kaplan-Meier estimator for right censored data. This version does empirical likelihood ratio test with right censored data with linear type constraint and hypothesis testing for coefficients in accelerated failure time model.
License: GPL (>= 2)
Depends: R (>= 2.13.1), compiler, rootSolve, emplik
URL: https://github.com/yfyang86/kmc
LinkingTo: Rcpp
NeedsCompilation: yes
BugReports: https://github.com/yfyang86/kmc
Packaged: 2015-11-22 18:51:28 UTC; inseven
Repository: CRAN
Date/Publication: 2015-11-23 12:20:35

## kmc 0.2-3

=== DESCRIPTION ===
Package: kmc
Version: 0.2-3
Title: Kaplan-Meier Estimator with Constraints for Right Censored Data
        -- a Recursive Computational Algorithm
Author: Yifan Yang <yifan.yang@transwarp.io> , Mai Zhou<mai@ms.uky.edu>
Maintainer: Yifan Yang <yifan.yang@uky.edu>
Description: Given constraints for right censored data, we use a recursive computational algorithm to calculate the the "constrained" Kaplan-Meier estimator. The constraint is assumed given in linear estimating equations or mean functions. We also illustrate how this leads to the empirical likelihood ratio test with right censored data and accelerated failure time model with given coefficients. EM algorithm from emplik package is used to get the initial value. The properties and performance of the EM algorithm is discussed in Mai Zhou and Yifan Yang (2015)<doi: 10.1007/s00180-015-0567-9> and Mai Zhou and Yifan Yang (2017) <10.1002/wics.1400>. More applications could be found in Mai Zhou (2015) <doi: 10.1201/b18598>.
URL: http://github.com/yfyang86/kmc
License: LGPL-3
Depends: R (>= 2.13.1), compiler, rootSolve, emplik
LinkingTo: Rcpp
NeedsCompilation: yes
Packaged: 2019-04-24 09:29:26.930 UTC; yifanyang
Repository: CRAN
Date/Publication: 2019-04-24 11:50:03 UTC

## kmc 0.2-4

=== DESCRIPTION ===
--- 
+++ 
@@ -1,5 +1,5 @@
 Package: kmc
-Version: 0.2-3
+Version: 0.2-4
 Title: Kaplan-Meier Estimator with Constraints for Right Censored Data
         -- a Recursive Computational Algorithm
 Author: Yifan Yang <yifan.yang@transwarp.io> , Mai Zhou<mai@ms.uky.edu>
@@ -10,6 +10,6 @@
 Depends: R (>= 2.13.1), compiler, rootSolve, emplik
 LinkingTo: Rcpp
 NeedsCompilation: yes
-Packaged: 2019-04-24 09:29:26.930 UTC; yifanyang
+Packaged: 2020-03-12 09:06:56.467 UTC; yifanyang
 Repository: CRAN
-Date/Publication: 2019-04-24 11:50:03 UTC
+Date/Publication: 2020-03-16 13:30:02 UTC

## kmc 0.4-2

=== DESCRIPTION ===
Package: kmc
Type: Package
Title: Kaplan-Meier Estimator with Constraints for Right Censored Data
        -- a Recursive Computational Algorithm
Version: 0.4-2
Date: 2022-11-21
Authors@R: c(person("Yifan", "Yang",  role = c("aut", "cre","cph"),
                   email = "yfyang.86@hotmail.com"),
            person("Mai", "Zhou", role = "aut"))
Maintainer: Yifan Yang <yfyang.86@hotmail.com>
Description: Given constraints for right censored data, we use a recursive computational algorithm to calculate the the "constrained" Kaplan-Meier estimator. The constraint is assumed given in linear estimating equations or mean functions. We also illustrate how this leads to the empirical likelihood ratio test with right censored data and accelerated failure time model with given coefficients. EM algorithm from emplik package is used to get the initial value. The properties and performance of the EM algorithm is discussed in Mai Zhou and Yifan Yang (2015)<doi: 10.1007/s00180-015-0567-9> and Mai Zhou and Yifan Yang (2017) <doi: 10.1002/wics.1400>. More applications could be found in Mai Zhou (2015) <doi: 10.1201/b18598>.
URL: https://github.com/yfyang86/kmc/
License: LGPL-3
Depends: R (>= 3.5), compiler, rootSolve, emplik
Suggests: survival, ggplot2, tidyr, testthat (>= 3.0.0)
LinkingTo: Rcpp
NeedsCompilation: yes
Encoding: UTF-8
Config/testthat/edition: 3
Packaged: 2022-11-22 01:45:11 UTC; yifanyang
Author: Yifan Yang [aut, cre, cph],
  Mai Zhou [aut]
Repository: CRAN
Date/Publication: 2022-11-22 08:30:02 UTC

## kmc 2.0+dfsg

=== debian/changelog ===
kmc (2.0+dfsg-2) unstable; urgency=medium

  * Set BOOST_LIB path fit for any arch
    Closes: #793843
  * Drop -m64 option
    Closes: #793835

 -- Andreas Tille <tille@debian.org>  Tue, 28 Jul 2015 08:05:11 +0200

kmc (2.0+dfsg-1) unstable; urgency=medium

  * Initial release (Closes: #770063)

 -- Jorge Soares <j.s.soares@gmail.com>  Mon, 03 Nov 2014 14:46:54 +0200

=== debian/control ===
Source: kmc
Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
Uploaders: Andreas Tille <tille@debian.org>,
           Jorge Soares <j.s.soares@gmail.com>
Section: science
Priority: optional
Build-Depends: debhelper (>= 9),
               zlib1g-dev,
	       libbz2-dev,
	       libboost-all-dev (>= 1.51),
	       help2man,
	       d-shlibs
Standards-Version: 3.9.6
Vcs-Browser: https://anonscm.debian.org/cgit/debian-med/kmc.git
Homepage: https://github.com/js21/kmc

Package: kmc
Architecture: any
Depends: ${shlibs:Depends},
         ${misc:Depends}
Description: count kmers in genomic sequences
 The kmc software is designed for counting k-mers (sequences of
 consecutive k symbols) in a set of reads K-mer counting is
 important for many bioinformatics applications, e.g.,
 developing de Bruijn graph assemblers.
 Building de Bruijn graphs is a commonly used approach for genome
 assembly with data from second-generation sequencer.
 Unfortunately, sequencing errors (frequent in practice)
 results in huge memory requirements for de Bruijn graphs, as well
 as long build time. One of the popular approaches to handle this
 problem is filtering the input reads in such a way that unique k-mers
 (very likely obtained as a result of an error) are discarded.
 .
 Thus, KMC scans the raw reads and produces a compact representation
 of all non-unique reads accompanied with number of their occurrences.
 The algorithm implemented in KMC makes use mostly of disk space rather
 than RAM, which allows one to use KMC even on rather typical personal
 computers. When run at high-end server (what is necessary for KMC
 competitors) it outperforms them in both memory requirements and
 speed of computation. The disk space necessary for computation is in
 order of the size of input data (usually it is smaller).

=== debian/rules ===
#!/usr/bin/make -f

export DH_VERBOSE := 1
DEBVERS := $(shell dpkg-parsechangelog | sed -n -e 's/^Version: //p')
VERSION := $(shell echo '$(DEBVERS)' | sed -e 's/^[0-9-]*://' -e 's/[~-].*//')
OVERSION := $(shell echo '$(DEBVERS)' | sed -e 's/^[[:digit:]]*://' -e 's/[+].*//')


mandir := $(CURDIR)/debian/man
debfolder := $(CURDIR)/debian

%:
	dh $@

override_dh_install:
	dh_install

override_dh_installman:
	mkdir -p $(mandir)
	$(debfolder)/usage_to_man
	dh_installman --

get-orig-source:
	uscan --verbose --force-download --repack --compression gz --destdir=..
	mv ../kmc_$(OVERSION).orig.tar.gz ../kmc_$(VERSION).orig.tar.gz

=== debian/watch ===
version=3
opts=dversionmangle=s/.+\/v?(\d\S*)\.tar\.gz/kmc-$1.tar.gz/,dversionmangle=s/.dfsg// \ 
	https://github.com/js21/kmc/releases .*/archive/v(\d[\d.-]+)\.(?:tar(?:\.gz|\.bz2)?|tgz)

## kmc 2.3%2Bdfsg

=== debian/changelog ===
kmc (2.3+dfsg-7build1) focal; urgency=medium

  * No-change rebuild for libgcc-s1 package name change.

 -- Matthias Klose <doko@ubuntu.com>  Sun, 22 Mar 2020 16:44:59 +0100

kmc (2.3+dfsg-7) unstable; urgency=medium

  [ Jelmer Vernooĳ ]
  * Trim trailing whitespace.
  * Use secure copyright file specification URI.

  [ Sascha Steinbiss ]
  * Fix install paths.
    Closes: #914376
  * Update my email address in Uploaders.

 -- Sascha Steinbiss <satta@debian.org>  Mon, 26 Nov 2018 21:22:30 +0100

kmc (2.3+dfsg-6) unstable; urgency=medium

  * Drop unneeded get-orig-source target
  * debhelper 11
  * Point Vcs fields to salsa.debian.org
  * Standards-Version: 4.1.5
  * Drop unnecessary Testsuite: autopkgtest
  * Do not parse d/changelog
  * Fix spelling

 -- Andreas Tille <tille@debian.org>  Wed, 11 Jul 2018 21:35:03 +0200

kmc (2.3+dfsg-5) unstable; urgency=medium

  * Add missing include to header, fixes FTBFS.
    Closes: #822390

 -- Sascha Steinbiss <sascha@steinbiss.name>  Sun, 24 Apr 2016 12:08:34 +0000

kmc (2.3+dfsg-4) unstable; urgency=low

  * Move LDFLAGS to end of linker call.
    Thanks to Steve Langasek for the patch (from Ubuntu).
  * Enable full hardening.

 -- Sascha Steinbiss <sascha@steinbiss.name>  Tue, 29 Mar 2016 20:28:59 +0000

kmc (2.3+dfsg-3) unstable; urgency=medium

  * Switch to asciidoctor for reproducible man page building.
  * Prevent strange FTBFS on some platforms caused by ronn.

 -- Sascha Steinbiss <sascha@steinbiss.name>  Thu, 10 Mar 2016 22:02:44 +0000

kmc (2.3+dfsg-2) unstable; urgency=medium

  * Make man page building reproducible.
  * Clean up d/rules.
  * Use secure Git-Vcs.
  * Bump Standards-Version.

 -- Sascha Steinbiss <sascha@steinbiss.name>  Wed, 09 Mar 2016 13:13:34 +0000

kmc (2.3+dfsg-1) unstable; urgency=medium

  [ Kevin Murray ]
  * Add libkmc-dev package

  [ Sascha Steinbiss ]
  * New upstream release
  * Incorporate new 'kmc_tools' executable and manpages
  * Add autopkgtest

 -- Sascha Steinbiss <sascha@steinbiss.name>  Sat, 19 Dec 2015 14:51:54 +0000

kmc (2.2+dfsg-1) unstable; urgency=low

  * New upstream release
  * d/watch: Adjusted to use actual upstream's github repo
  * Rework patches to fit new upstream build system
  * Add citation

 -- Sascha Steinbiss <sascha@steinbiss.name>  Sun, 23 Aug 2015 15:32:16 +0000

## kmc 2.3+dfsg

=== debian/control ===
Source: kmc
Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
Uploaders: Andreas Tille <tille@debian.org>,
           Jorge Soares <j.s.soares@gmail.com>,
           Sascha Steinbiss <sascha@steinbiss.name>,
           Kevin Murray <spam@kdmurray.id.au>
Section: science
Priority: optional
Build-Depends: debhelper (>= 9),
               dh-exec,
               zlib1g-dev,
               libbz2-dev,
               help2man,
               asciidoctor,
               d-shlibs
Standards-Version: 3.9.7
Testsuite: autopkgtest
Vcs-Browser: https://anonscm.debian.org/cgit/debian-med/kmc.git
Vcs-Git: https://anonscm.debian.org/git/debian-med/kmc.git
Homepage: http://sun.aei.polsl.pl/kmc

Package: kmc
Architecture: any
Depends: ${shlibs:Depends},
         ${misc:Depends}
Description: count kmers in genomic sequences
 The kmc software is designed for counting k-mers (sequences of
 consecutive k symbols) in a set of reads. K-mer counting is
 important for many bioinformatics applications, e.g. developing de Bruijn
 graph assemblers.
 .
 Building de Bruijn graphs is a commonly used approach for genome
 assembly with data from second-generation sequencing.
 Unfortunately, sequencing errors (frequent in practice)
 result in huge memory requirements for de Bruijn graphs, as well
 as long build time. One of the popular approaches to handle this
 problem is filtering the input reads in such a way that unique k-mers
 (very likely obtained as a result of an error) are discarded.
 .
 Thus, KMC scans the raw reads and produces a compact representation
 of all non-unique reads accompanied with number of their occurrences.
 The algorithm implemented in KMC makes use mostly of disk space rather
 than RAM, which allows one to use KMC even on rather typical personal
 computers. When run on high-end servers (what is necessary for KMC
 competitors) it outperforms them in both memory requirements and
 speed of computation. The disk space necessary for computation is in
 order of the size of input data (usually it is smaller).

Package: libkmc-dev
Section: libdevel
Architecture: any
Depends: ${shlibs:Depends},
         ${misc:Depends}
Description: library to access KMC k-mer count files
 The kmc software is designed for counting k-mers (sequences of
 consecutive k symbols) in a set of reads. K-mer counting is
 important for many bioinformatics applications, e.g. developing de Bruijn
 graph assemblers.
 .
 This package contains the C++ library headers for accessing kmc's output
 file format.

=== debian/rules ===
#!/usr/bin/make -f

export DH_VERBOSE := 1
export DEB_BUILD_MAINT_OPTIONS = hardening=+all
DATE := $(shell dpkg-parsechangelog -S Date)

mandir := $(CURDIR)/debian/man
debfolder := $(CURDIR)/debian

%:
	dh $@ --parallel

override_dh_install:
	dh_install

override_dh_auto_clean:
	rm -rf $(debfolder)/man_src/*.html $(debfolder)/man_src/*.?
	rm -rf $(mandir)
	dh_auto_clean --

override_dh_installman:
	mkdir -p $(mandir)
	$(debfolder)/usage_to_man
	asciidoctor -a docdate='' -b manpage $(debfolder)/man_src/*.adoc
	cp $(debfolder)/man_src/*.? $(mandir)
	dh_installman --

get-orig-source:
	uscan --verbose --force-download --repack --compression gz --destdir=..

=== debian/watch ===
version=3
opts="repacksuffix=+dfsg,dversionmangle=s/.dfsg//,filenamemangle=s/(?:.*?)?v?(\d[\d.]*)\.tar\.gz/kmc_$1.tar.gz/" \
	https://github.com/marekkokot/KMC/releases .*/archive/(\d[\d.-]+)\.(?:tar(?:\.gz|\.bz2)?|tgz)

## kmc 3.1.1+dfsg

=== debian/changelog ===
kmc (3.1.1+dfsg-3) unstable; urgency=medium

  * Team upload.
  * Adjust simde patch to fix i386 FTFBS.

 -- Michael R. Crusoe <crusoe@debian.org>  Fri, 22 Jan 2021 13:43:22 +0100

kmc (3.1.1+dfsg-2) unstable; urgency=medium

  * Team upload.

  [ Étienne Mollier ]
  * Remove non-portable -m64 flag put back by error.

  [ Michael R. Crusoe ]
  * Support non-x86 systems via libsimde-dev. Closes: #977498

 -- Michael R. Crusoe <crusoe@debian.org>  Fri, 22 Jan 2021 11:53:55 +0100

kmc (3.1.1+dfsg-1) unstable; urgency=medium

  * Added myself to Uploaders.
  * New upstream version (Closes: #954270)
  * Remove changes related to asmlib, not used upstream anymore.
  * Refresh use-shared-libs patch.
  * Fold patches to makefile into makefile.patch.
  * Refresh 0005-Add-static-library-target-to-makefile.patch.
  * Wrote a new spelling patch as previous patch has been applied upstream.
  * Refresh patch newish_gcc_build_fix.patch
  * Removed patch cap-default-thread-count.patch
  * Activated highly threaded test in autopkgtest
  * Disable the newer python3 bindings for the moment.

 -- Étienne Mollier <etienne.mollier@mailoo.org>  Thu, 10 Dec 2020 21:59:30 +0100

kmc (2.3+dfsg-10) unstable; urgency=medium

  * Add cap-default-thread-count.patch. (Closes: #954270)
  * Fix d/watch to find newer upstream versions.
  * Update autopkgtest: test single-threaded and default option independently.

 -- Étienne Mollier <etienne.mollier@mailoo.org>  Tue, 08 Dec 2020 21:21:51 +0100

kmc (2.3+dfsg-9) unstable; urgency=medium

  * Team upload.
  * Standards-Version: 4.5.1 (routine-update)
  * debhelper-compat 13 (routine-update)
  * Add salsa-ci file (routine-update)
  * Rules-Requires-Root: no (routine-update)
  * Set upstream metadata fields: Repository, Repository-Browse.
  * Autopkgtest changes:
    - increase verbosity in hope to see more things in case #954270 reoccurs,
    - allow output to standard error.
  * Update d/watch to format version 4.

 -- Étienne Mollier <etienne.mollier@mailoo.org>  Sun, 06 Dec 2020 18:51:47 +0100

kmc (2.3+dfsg-8) unstable; urgency=medium

  * Add ref to conda (Thanks Steffen Moeller).
  * Fix EDAM syntax (Thanks Andreas Tille).
  * Bump Standards-Version.
  * Use debhelper-compat 12.
  * Add missing DEP-12 fields.

 -- Sascha Steinbiss <satta@debian.org>  Fri, 17 Apr 2020 12:10:42 +0200

=== debian/control ===
--- 
+++ 
@@ -2,25 +2,28 @@
 Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
 Uploaders: Andreas Tille <tille@debian.org>,
            Jorge Soares <j.s.soares@gmail.com>,
-           Sascha Steinbiss <sascha@steinbiss.name>,
-           Kevin Murray <spam@kdmurray.id.au>
+           Sascha Steinbiss <satta@debian.org>,
+           Kevin Murray <spam@kdmurray.id.au>,
+           Étienne Mollier <etienne.mollier@mailoo.org>
 Section: science
 Priority: optional
-Build-Depends: debhelper (>= 9),
+Build-Depends: debhelper-compat (= 13),
                dh-exec,
                zlib1g-dev,
                libbz2-dev,
                help2man,
                asciidoctor,
-               d-shlibs
-Standards-Version: 3.9.7
-Testsuite: autopkgtest
-Vcs-Browser: https://anonscm.debian.org/cgit/debian-med/kmc.git
-Vcs-Git: https://anonscm.debian.org/git/debian-med/kmc.git
+               d-shlibs,
+               libsimde-dev
+Standards-Version: 4.5.1
+Vcs-Browser: https://salsa.debian.org/med-team/kmc
+Vcs-Git: https://salsa.debian.org/med-team/kmc.git
 Homepage: http://sun.aei.polsl.pl/kmc
+Rules-Requires-Root: no
 
 Package: kmc
 Architecture: any
+Built-Using: ${simde:Built-Using}
 Depends: ${shlibs:Depends},
          ${misc:Depends}
 Description: count kmers in genomic sequences
@@ -47,8 +50,9 @@
  order of the size of input data (usually it is smaller).
 
 Package: libkmc-dev
+Built-Using: ${simde:Built-Using}
+Architecture: any
 Section: libdevel
-Architecture: any
 Depends: ${shlibs:Depends},
          ${misc:Depends}
 Description: library to access KMC k-mer count files

=== debian/rules ===
--- 
+++ 
@@ -2,13 +2,26 @@
 
 export DH_VERBOSE := 1
 export DEB_BUILD_MAINT_OPTIONS = hardening=+all
-DATE := $(shell dpkg-parsechangelog -S Date)
+
+export DEB_CFLAGS_MAINT_APPEND+=-DSIMDE_ENABLE_OPENMP -fopenmp-simd -O3
+export DEB_CXXFLAGS_MAINT_APPEND+=-DSIMDE_ENABLE_OPENMP -fopenmp-simd -O3
+
+include /usr/share/dpkg/default.mk
+DATE := $(SOURCE_DATE_EPOCH)
 
 mandir := $(CURDIR)/debian/man
 debfolder := $(CURDIR)/debian
 
+
 %:
-	dh $@ --parallel
+	dh $@
+
+override_dh_auto_build:
+ifneq (,$(filter $(DEB_HOST_ARCH),amd64 i386))
+	dh_auto_build -- SIMD=1
+else
+	dh_auto_build
+endif
 
 override_dh_install:
 	dh_install
@@ -25,5 +38,5 @@
 	cp $(debfolder)/man_src/*.? $(mandir)
 	dh_installman --
 
-get-orig-source:
-	uscan --verbose --force-download --repack --compression gz --destdir=..
+override_dh_gencontrol:
+	dh_gencontrol -- -Vsimde:Built-Using="$(shell dpkg-query -f '$${source:Package} (= $${source:Version}), ' -W "libsimde-dev")"

=== debian/watch ===
version=4

opts="repacksuffix=+dfsg,dversionmangle=auto,filenamemangle=s/(?:.*?)?v?(\d[\d.]*)\.tar\.gz/kmc_$1.tar.gz/" \
	https://github.com/marekkokot/KMC/releases \
	.*/archive/v?(\d[\d.-]+)\.(?:tar(?:\.gz|\.bz2)?|tgz)

## kmc 3.2.1%2Bdfsg

=== debian/changelog ===
kmc (3.2.1+dfsg-1) unstable; urgency=medium

  * New upstream version
  * Add missing build dependency on dh addon.
  * Drop transition for old debug package migration.
  * d/copyright: update Files-Excluded pattern list
  * Refresh all patches following reorganisation of upstream source code.
  * Delete newish_gcc_build_fix.patch: applied upstream.
  * d/t/build-lib: adjust autopkgtest to limitations imposed by upstream:
    no less than 2GiB of memory per command and no more than 128 threads.
  * d/control,d/libkmc-dev: don't depend on dh-exec thanks to compat 13.

 -- Étienne Mollier <emollier@debian.org>  Sun, 16 Jan 2022 15:24:16 +0100

kmc (3.1.1+dfsg-4) unstable; urgency=medium

  [ Michael R. Crusoe ]
  * debian/control: mark libkmc-dev as Multi-Arch: same

  [ Étienne Mollier ]
  * d/control: update my uploader address
  * d/watch: fix broken link to github
  * add support-mixed-march.patch (Closes: #983930)
  * Standards-Version: 4.6.0 (routine-update)
  * d/usage_to_man: adjust directory creation; fixes a spurious "Can't exec "1""
    error message at build time

 -- Étienne Mollier <emollier@debian.org>  Sun, 22 Aug 2021 12:09:16 +0200

## kmc 3.2.1+dfsg

=== Makefile ===
all: kmc kmc_dump kmc_tools py_kmc_api

UNAME_S := $(shell uname -s)

KMC_MAIN_DIR = kmc_core
KMC_CLI_DIR = kmc_CLI
KMC_API_DIR = kmc_api
KMC_DUMP_DIR = kmc_dump
KMC_TOOLS_DIR = kmc_tools
PY_KMC_API_DIR = py_kmc_api

OUT_BIN_DIR = bin
OUT_INCLUDE_DIR = include

ifeq ($(UNAME_S),Darwin)
	CC = /usr/local/bin/g++-10

	CFLAGS	= -Wall -O3 -m64 -static-libgcc -static-libstdc++ -pthread -std=c++14
	CLINK	= -lm -static-libgcc -static-libstdc++ -O3 -pthread -std=c++14

	PY_KMC_API_CFLAGS = -Wl,-undefined,dynamic_lookup -fPIC -Wall -shared -std=c++14 -O3
else
	CC 	= g++

	CFLAGS	= -Wall -O3 -m64 -static -Wl,--whole-archive -lpthread -Wl,--no-whole-archive -std=c++14
	CLINK	= -lm -static -O3 -Wl,--whole-archive -lpthread -Wl,--no-whole-archive -std=c++14

	PY_KMC_API_CFLAGS = -fPIC -Wall -shared -std=c++14 -O3
endif

KMC_CLI_OBJS = \
$(KMC_CLI_DIR)/kmc.o

KFF_OBJS = \
$(KMC_MAIN_DIR)/kff_writer.o

KMC_CORE_OBJS = \
$(KMC_MAIN_DIR)/mem_disk_file.o \
$(KMC_MAIN_DIR)/rev_byte.o \
$(KMC_MAIN_DIR)/bkb_writer.o \
$(KMC_MAIN_DIR)/cpu_info.o \
$(KMC_MAIN_DIR)/bkb_reader.o \
$(KMC_MAIN_DIR)/fastq_reader.o \
$(KMC_MAIN_DIR)/timer.o \
$(KMC_MAIN_DIR)/develop.o \
$(KMC_MAIN_DIR)/kb_completer.o \
$(KMC_MAIN_DIR)/kb_storer.o \
$(KMC_MAIN_DIR)/kmer.o \
$(KMC_MAIN_DIR)/splitter.o \
$(KMC_MAIN_DIR)/kb_collector.o \
$(KMC_MAIN_DIR)/kmc_runner.o

ifeq ($(UNAME_S),Darwin)
	RADULS_OBJS =

	KMC_LIBS = \
	$(KMC_MAIN_DIR)/libs/libz.1.2.5.dylib \
	$(KMC_MAIN_DIR)/libs/libbz2.1.0.5.dylib

	KMC_TOOLS_LIBS = \
	$(KMC_TOOLS_DIR)/libs/libz.1.2.5.dylib \
	$(KMC_TOOLS_DIR)/libs/libbz2.1.0.5.dylib

	LIB_KMC_CORE = $(OUT_BIN_DIR)/libkmc_core.mac.a
else
	RADULS_OBJS = \
	$(KMC_MAIN_DIR)/raduls_sse2.o \
	$(KMC_MAIN_DIR)/raduls_sse41.o \
	$(KMC_MAIN_DIR)/raduls_avx2.o \
	$(KMC_MAIN_DIR)/raduls_avx.o

	KMC_LIBS = \
	$(KMC_MAIN_DIR)/libs/libz.a \
	$(KMC_MAIN_DIR)/libs/libbz2.a

	KMC_TOOLS_LIBS = \
	$(KMC_TOOLS_DIR)/libs/libz.a \
	$(KMC_TOOLS_DIR)/libs/libbz2.a

	LIB_KMC_CORE = $(OUT_BIN_DIR)/libkmc_core.a
endif


KMC_DUMP_OBJS = \
$(KMC_DUMP_DIR)/nc_utils.o \
$(KMC_DUMP_DIR)/kmc_dump.o

KMC_API_OBJS = \
$(KMC_API_DIR)/mmer.o \
$(KMC_API_DIR)/kmc_file.o \
$(KMC_API_DIR)/kmer_api.o

KMC_API_SRC_FILES = $(wildcard $(KMC_API_DIR)/*.cpp)
PY_KMC_API_OBJS = $(patsubst $(KMC_API_DIR)/%.cpp,$(PY_KMC_API_DIR)/%.o,$(KMC_API_SRC_FILES))

KMC_TOOLS_OBJS = \
$(KMC_TOOLS_DIR)/kmer_file_header.o \
$(KMC_TOOLS_DIR)/kmc_tools.o \
$(KMC_TOOLS_DIR)/nc_utils.o \
$(KMC_TOOLS_DIR)/parameters_parser.o \
$(KMC_TOOLS_DIR)/parser.o \
$(KMC_TOOLS_DIR)/tokenizer.o \
$(KMC_TOOLS_DIR)/fastq_filter.o \
$(KMC_TOOLS_DIR)/fastq_reader.o \
$(KMC_TOOLS_DIR)/fastq_writer.o \
$(KMC_TOOLS_DIR)/percent_progress.o \
$(KMC_TOOLS_DIR)/kff_info_reader.o


$(KMC_CLI_OBJS) $(KMC_CORE_OBJS) $(KMC_DUMP_OBJS) $(KMC_API_OBJS) $(KFF_OBJS) $(KMC_TOOLS_OBJS): %.o: %.cpp
	$(CC) $(CFLAGS) -c $< -o $@

$(KMC_MAIN_DIR)/raduls_sse2.o: $(KMC_MAIN_DIR)/raduls_sse2.cpp
	$(CC) $(CFLAGS) -msse2 -c $< -o $@
$(KMC_MAIN_DIR)/raduls_sse41.o: $(KMC_MAIN_DIR)/raduls_sse41.cpp
	$(CC) $(CFLAGS) -msse4.1 -c $< -o $@
$(KMC_MAIN_DIR)/raduls_avx.o: $(KMC_MAIN_DIR)/raduls_avx.cpp
	$(CC) $(CFLAGS) -mavx -c $< -o $@
$(KMC_MAIN_DIR)/raduls_avx2.o: $(KMC_MAIN_DIR)/raduls_avx2.cpp
	$(CC) $(CFLAGS) -mavx2 -c $< -o $@

$(LIB_KMC_CORE): $(KMC_CORE_OBJS) $(RADULS_OBJS) $(KMC_API_OBJS) $(KFF_OBJS)
	-mkdir -p $(OUT_INCLUDE_DIR)
	cp $(KMC_MAIN_DIR)/kmc_runner.h $(OUT_INCLUDE_DIR)/kmc_runner.h
	-mkdir -p $(OUT_BIN_DIR)
	ar rcs $@ $^

kmc: $(KMC_CLI_OBJS) $(LIB_KMC_CORE)
	-mkdir -p $(OUT_BIN_DIR)
	$(CC) $(CLINK) -o $(OUT_BIN_DIR)/$@ $^ $(KMC_LIBS)

kmc_dump: $(KMC_DUMP_OBJS) $(KMC_API_OBJS)
	-mkdir -p $(OUT_BIN_DIR)
	$(CC) $(CLINK) -o $(OUT_BIN_DIR)/$@ $^

kmc_tools: $(KMC_TOOLS_OBJS) $(KMC_API_OBJS) $(KFF_OBJS)
	-mkdir -p $(OUT_BIN_DIR)
	$(CC) $(CLINK) -o $(OUT_BIN_DIR)/$@ $^ $(KMC_TOOLS_LIBS)

$(PY_KMC_API_DIR)/%.o: $(KMC_API_DIR)/%.cpp
	$(CC) -c -fPIC -Wall -O3 -m64 -std=c++14 $^ -o $@

py_kmc_api: $(PY_KMC_API_OBJS) $(PY_KMC_API_OBJS)
	-mkdir -p $(OUT_BIN_DIR)
	$(CC) $(PY_KMC_API_CFLAGS) $(PY_KMC_API_DIR)/py_kmc_api.cpp $(PY_KMC_API_OBJS) \
	-I $(KMC_API_DIR) \
	-I $(PY_KMC_API_DIR)/libs/pybind11/include \
	-I `python3 -c "import sysconfig;print(sysconfig.get_paths()['include'])"` \
	-o $(OUT_BIN_DIR)/$@`python3-config --extension-suffix`

clean:
	-rm -f $(KMC_MAIN_DIR)/*.o
	-rm -f $(KMC_API_DIR)/*.o
	-rm -f $(KMC_DUMP_DIR)/*.o
	-rm -f $(KMC_TOOLS_DIR)/*.o
	-rm -f $(PY_KMC_API_DIR)/*.o
	-rm -f $(PY_KMC_API_DIR)/*.so
	-rm -rf $(OUT_BIN_DIR)
	-rm -rf $(OUT_INCLUDE_DIR)

=== debian/changelog ===
kmc (3.2.1+dfsg-2~0exp0simde) experimental; urgency=medium

  * Team upload.
  * Experimental rebuild with SIMDe 0.7.3~0git20230118123246.d1e75cd

 -- Michael R. Crusoe <crusoe@debian.org>  Sun, 22 Jan 2023 18:51:41 +0100

=== debian/control ===
--- 
+++ 
@@ -4,18 +4,18 @@
            Jorge Soares <j.s.soares@gmail.com>,
            Sascha Steinbiss <satta@debian.org>,
            Kevin Murray <spam@kdmurray.id.au>,
-           Étienne Mollier <etienne.mollier@mailoo.org>
+           Étienne Mollier <emollier@debian.org>
 Section: science
 Priority: optional
 Build-Depends: debhelper-compat (= 13),
-               dh-exec,
                zlib1g-dev,
                libbz2-dev,
                help2man,
                asciidoctor,
                d-shlibs,
-               libsimde-dev
-Standards-Version: 4.5.1
+               libsimde-dev (>= 0.7.3~0git20230118123246.d1e75cd),
+               debhelper
+Standards-Version: 4.6.0
 Vcs-Browser: https://salsa.debian.org/med-team/kmc
 Vcs-Git: https://salsa.debian.org/med-team/kmc.git
 Homepage: http://sun.aei.polsl.pl/kmc
@@ -52,6 +52,7 @@
 Package: libkmc-dev
 Built-Using: ${simde:Built-Using}
 Architecture: any
+Multi-Arch: same
 Section: libdevel
 Depends: ${shlibs:Depends},
          ${misc:Depends}

## kmc 3.2.2+dfsg

=== Makefile ===
--- 
+++ 
@@ -1,6 +1,8 @@
 all: kmc kmc_dump kmc_tools py_kmc_api
 
 UNAME_S := $(shell uname -s)
+UNAME_M := $(shell uname -m)
+UNAME_P := $(shell uname -p)
 
 KMC_MAIN_DIR = kmc_core
 KMC_CLI_DIR = kmc_CLI
@@ -12,21 +14,62 @@
 OUT_BIN_DIR = bin
 OUT_INCLUDE_DIR = include
 
+D_OS =
+D_ARCH = 
+
 ifeq ($(UNAME_S),Darwin)
-	CC = /usr/local/bin/g++-10
-
-	CFLAGS	= -Wall -O3 -m64 -static-libgcc -static-libstdc++ -pthread -std=c++14
-	CLINK	= -lm -static-libgcc -static-libstdc++ -O3 -pthread -std=c++14
-
-	PY_KMC_API_CFLAGS = -Wl,-undefined,dynamic_lookup -fPIC -Wall -shared -std=c++14 -O3
+	D_OS=MACOS
+	ifeq ($(UNAME_M),arm64)
+		D_ARCH=ARM64
+	else
+		D_ARCH=X64
+	endif
+else
+	D_OS=LINUX
+	D_ARCH=X64
+	ifeq ($(UNAME_M),arm64)
+		D_ARCH=ARM64
+	endif
+	ifeq ($(UNAME_M),aarch64)
+		D_ARCH=ARM64
+	endif
+endif
+
+CPU_FLAGS =
+STATIC_CFLAGS = 
+STATIC_LFLAGS = 
+PY_FLAGS =
+
+ifeq ($(D_OS),MACOS)
+	CC = g++-11
+
+	ifeq ($(D_ARCH),ARM64)
+		CPU_FLAGS = -march=armv8.4-a
+	else
+		CPU_FLAGS = -m64
+	endif
+	STATIC_CFLAGS = -static-libgcc -static-libstdc++ -pthread
+	STATIC_LFLAGS = -static-libgcc -static-libstdc++ -pthread	
+	PY_FLAGS = -Wl,-undefined,dynamic_lookup -fPIC 
 else
 	CC 	= g++
 
-	CFLAGS	= -Wall -O3 -m64 -static -Wl,--whole-archive -lpthread -Wl,--no-whole-archive -std=c++14
-	CLINK	= -lm -static -O3 -Wl,--whole-archive -lpthread -Wl,--no-whole-archive -std=c++14
-
-	PY_KMC_API_CFLAGS = -fPIC -Wall -shared -std=c++14 -O3
-endif
+	ifeq ($(D_ARCH),ARM64)
+		CPU_FLAGS = -march=armv8-a
+		STATIC_CFLAGS =
+		STATIC_LFLAGS = -static-libgcc -static-libstdc++ -pthread	
+	else
+		CPU_FLAGS = -m64
+		STATIC_CFLAGS = -static -Wl,--whole-archive -lpthread -Wl,--no-whole-archive
+		STATIC_LFLAGS = -static -Wl,--whole-archive -lpthread -Wl,--no-whole-archive
+	endif
+	PY_FLAGS = -fPIC
+endif
+
+
+CFLAGS	= -Wall -O3 -fsigned-char $(CPU_FLAGS) $(STATIC_CFLAGS) -std=c++14
+CLINK	= -lm $(STATIC_LFLAGS) -O3 -std=c++14
+PY_KMC_API_CFLAGS = $(PY_FLAGS) -Wall -shared -std=c++14 -O3
 
 KMC_CLI_OBJS = \
 $(KMC_CLI_DIR)/kmc.o
@@ -51,34 +94,27 @@
 $(KMC_MAIN_DIR)/kmc_runner.o
 
 ifeq ($(UNAME_S),Darwin)
+ifeq ($(D_ARCH),ARM64)
+	RADULS_OBJS = \
+	$(KMC_MAIN_DIR)/raduls_neon.o
+else
 	RADULS_OBJS =
-
-	KMC_LIBS = \
-	$(KMC_MAIN_DIR)/libs/libz.1.2.5.dylib \
-	$(KMC_MAIN_DIR)/libs/libbz2.1.0.5.dylib
-
-	KMC_TOOLS_LIBS = \
-	$(KMC_TOOLS_DIR)/libs/libz.1.2.5.dylib \
-	$(KMC_TOOLS_DIR)/libs/libbz2.1.0.5.dylib
-
-	LIB_KMC_CORE = $(OUT_BIN_DIR)/libkmc_core.mac.a
+endif
+else
+ifeq ($(D_ARCH),ARM64)
+	RADULS_OBJS = \
+	$(KMC_MAIN_DIR)/raduls_neon.o
 else
 	RADULS_OBJS = \
 	$(KMC_MAIN_DIR)/raduls_sse2.o \
 	$(KMC_MAIN_DIR)/raduls_sse41.o \
 	$(KMC_MAIN_DIR)/raduls_avx2.o \
 	$(KMC_MAIN_DIR)/raduls_avx.o
-
-	KMC_LIBS = \
-	$(KMC_MAIN_DIR)/libs/libz.a \
-	$(KMC_MAIN_DIR)/libs/libbz2.a
-
-	KMC_TOOLS_LIBS = \
-	$(KMC_TOOLS_DIR)/libs/libz.a \
-	$(KMC_TOOLS_DIR)/libs/libbz2.a
-
-	LIB_KMC_CORE = $(OUT_BIN_DIR)/libkmc_core.a
-endif
+endif
+endif
+
+LIB_ZLIB=3rd_party/cloudflare/libz.a
+LIB_KMC_CORE = $(OUT_BIN_DIR)/libkmc_core.a
 
 
 KMC_DUMP_OBJS = \
@@ -106,9 +142,11 @@
 $(KMC_TOOLS_DIR)/percent_progress.o \
 $(KMC_TOOLS_DIR)/kff_info_reader.o
 
+$(LIB_ZLIB):
+	cd 3rd_party/cloudflare; ./configure; make libz.a
 
 $(KMC_CLI_OBJS) $(KMC_CORE_OBJS) $(KMC_DUMP_OBJS) $(KMC_API_OBJS) $(KFF_OBJS) $(KMC_TOOLS_OBJS): %.o: %.cpp
-	$(CC) $(CFLAGS) -c $< -o $@
+	$(CC) $(CFLAGS) -I 3rd_party/cloudflare -c $< -o $@
 
 $(KMC_MAIN_DIR)/raduls_sse2.o: $(KMC_MAIN_DIR)/raduls_sse2.cpp
 	$(CC) $(CFLAGS) -msse2 -c $< -o $@
@@ -119,26 +157,30 @@
 $(KMC_MAIN_DIR)/raduls_avx2.o: $(KMC_MAIN_DIR)/raduls_avx2.cpp
 	$(CC) $(CFLAGS) -mavx2 -c $< -o $@
 
+$(KMC_MAIN_DIR)/raduls_neon.o: $(KMC_MAIN_DIR)/raduls_neon.cpp
+	$(CC) $(CFLAGS) -c $< -o $@
+
+
 $(LIB_KMC_CORE): $(KMC_CORE_OBJS) $(RADULS_OBJS) $(KMC_API_OBJS) $(KFF_OBJS)
 	-mkdir -p $(OUT_INCLUDE_DIR)
 	cp $(KMC_MAIN_DIR)/kmc_runner.h $(OUT_INCLUDE_DIR)/kmc_runner.h
 	-mkdir -p $(OUT_BIN_DIR)
 	ar rcs $@ $^
 
-kmc: $(KMC_CLI_OBJS) $(LIB_KMC_CORE)
-	-mkdir -p $(OUT_BIN_DIR)
-	$(CC) $(CLINK) -o $(OUT_BIN_DIR)/$@ $^ $(KMC_LIBS)
+kmc: $(KMC_CLI_OBJS) $(LIB_KMC_CORE) $(LIB_ZLIB)
+	-mkdir -p $(OUT_BIN_DIR)
+	$(CC) $(CLINK) -o $(OUT_BIN_DIR)/$@ $^ $(LIB_ZLIB)
 
 kmc_dump: $(KMC_DUMP_OBJS) $(KMC_API_OBJS)
 	-mkdir -p $(OUT_BIN_DIR)
 	$(CC) $(CLINK) -o $(OUT_BIN_DIR)/$@ $^
 
-kmc_tools: $(KMC_TOOLS_OBJS) $(KMC_API_OBJS) $(KFF_OBJS)
-	-mkdir -p $(OUT_BIN_DIR)
-	$(CC) $(CLINK) -o $(OUT_BIN_DIR)/$@ $^ $(KMC_TOOLS_LIBS)
+kmc_tools: $(KMC_TOOLS_OBJS) $(KMC_API_OBJS) $(KFF_OBJS) $(LIB_ZLIB)
+	-mkdir -p $(OUT_BIN_DIR)
+	$(CC) $(CLINK) -I 3rd_party/cloudflare -o $(OUT_BIN_DIR)/$@ $^ $(LIB_ZLIB)
 
 $(PY_KMC_API_DIR)/%.o: $(KMC_API_DIR)/%.cpp
-	$(CC) -c -fPIC -Wall -O3 -m64 -std=c++14 $^ -o $@
+	$(CC) -c -fPIC -Wall -O3 $(CPU_FLAGS) -std=c++14 $^ -o $@
 
 py_kmc_api: $(PY_KMC_API_OBJS) $(PY_KMC_API_OBJS)
 	-mkdir -p $(OUT_BIN_DIR)
@@ -157,3 +199,4 @@
 	-rm -f $(PY_KMC_API_DIR)/*.so
 	-rm -rf $(OUT_BIN_DIR)
 	-rm -rf $(OUT_INCLUDE_DIR)
+	cd 3rd_party/cloudflare; make clean;

=== debian/changelog ===
kmc (3.2.2+dfsg-1) unstable; urgency=medium

  * New upstream version
  * Standards-Version: 4.6.2 (routine-update)
  * Use secure URI in Homepage field.
  * use-shared-libs patch: refresh; forward not-needed.
  * makefile.patch: refresh; forwarding not-needed.
  * disable-python-bindings.patch: refresh.
  * simde patch: refresh.
  * support-mixed-march.patch: refresh.
  * gcc-13.patch: new: fix build failures with gcc-13. (Closes: #1037708)

 -- Étienne Mollier <emollier@debian.org>  Mon, 17 Jul 2023 12:35:26 +0200

## kmc 3.2.3+dfsg

=== debian/changelog ===
kmc (3.2.3+dfsg-1) unstable; urgency=medium

  * New upstream version

 -- Étienne Mollier <emollier@debian.org>  Wed, 13 Dec 2023 18:08:05 +0100

kmc (3.2.2+dfsg-2) unstable; urgency=medium

  * d/clean: new: cleanup various build artifacts. (Closes: #1049134)
  * d/rules: remove unnecessary dh_auto_clean override.
    The further files cleansed have been listed in d/clean.
  * spelling.patch: further fixes against typos.

 -- Étienne Mollier <emollier@debian.org>  Tue, 05 Dec 2023 17:54:14 +0100

## kmc 3.2.4%2Bdfsg

=== debian/changelog ===
kmc (3.2.4+dfsg-1build1) resolute; urgency=medium

  * No-change mass rebuild for Ubuntu 26.04 (LP: #2132257)

 -- Graham Inggs <ginggs@ubuntu.com>  Mon, 15 Dec 2025 21:28:57 +0000

kmc (3.2.4+dfsg-1) unstable; urgency=medium

  * New upstream version.

 -- Sascha Steinbiss <satta@debian.org>  Sat, 17 Feb 2024 15:01:25 +0100

## kmc 3.2.4+dfsg

=== Makefile ===
--- 
+++ 
@@ -1,4 +1,6 @@
 all: kmc kmc_dump kmc_tools py_kmc_api
+
+dummy := $(shell git submodule update --init --recursive)
 
 UNAME_S := $(shell uname -s)
 UNAME_M := $(shell uname -m)
@@ -169,7 +171,7 @@
 
 kmc: $(KMC_CLI_OBJS) $(LIB_KMC_CORE) $(LIB_ZLIB)
 	-mkdir -p $(OUT_BIN_DIR)
-	$(CC) $(CLINK) -o $(OUT_BIN_DIR)/$@ $^ $(LIB_ZLIB)
+	$(CC) $(CLINK) -o $(OUT_BIN_DIR)/$@ $^
 
 kmc_dump: $(KMC_DUMP_OBJS) $(KMC_API_OBJS)
 	-mkdir -p $(OUT_BIN_DIR)
@@ -177,7 +179,7 @@
 
 kmc_tools: $(KMC_TOOLS_OBJS) $(KMC_API_OBJS) $(KFF_OBJS) $(LIB_ZLIB)
 	-mkdir -p $(OUT_BIN_DIR)
-	$(CC) $(CLINK) -I 3rd_party/cloudflare -o $(OUT_BIN_DIR)/$@ $^ $(LIB_ZLIB)
+	$(CC) $(CLINK) -I 3rd_party/cloudflare -o $(OUT_BIN_DIR)/$@ $^
 
 $(PY_KMC_API_DIR)/%.o: $(KMC_API_DIR)/%.cpp
 	$(CC) -c -fPIC -Wall -O3 $(CPU_FLAGS) -std=c++14 $^ -o $@

=== tests/kmc_CLI/trivial-k-mer-counter/Makefile ===
CC = g++
CFLAGS = -std=c++20 -O3 -Wall -pedantic-errors

all: bin/counter

main.o: main.cpp
	$(CC) $(CFLAGS) -c -o $@ main.cpp

bin/counter: main.o
	mkdir -p bin
	$(CC) $(CFLAGS) -o $@ $^ -lz 


clean:
	rm -f *.o
	rm -rf bin

=== debian/control ===
--- 
+++ 
@@ -13,12 +13,12 @@
                help2man,
                asciidoctor,
                d-shlibs,
-               libsimde-dev (>= 0.7.3~0git20230118123246.d1e75cd),
+               libsimde-dev,
                debhelper
-Standards-Version: 4.6.0
+Standards-Version: 4.6.2
 Vcs-Browser: https://salsa.debian.org/med-team/kmc
 Vcs-Git: https://salsa.debian.org/med-team/kmc.git
-Homepage: http://sun.aei.polsl.pl/kmc
+Homepage: https://sun.aei.polsl.pl/kmc
 Rules-Requires-Root: no
 
 Package: kmc

=== debian/rules ===
--- 
+++ 
@@ -23,14 +23,6 @@
 	dh_auto_build
 endif
 
-override_dh_install:
-	dh_install
-
-override_dh_auto_clean:
-	rm -rf $(debfolder)/man_src/*.html $(debfolder)/man_src/*.?
-	rm -rf $(mandir)
-	dh_auto_clean --
-
 override_dh_installman:
 	mkdir -p $(mandir)
 	$(debfolder)/usage_to_man

=== debian/watch ===
version=4

opts="repacksuffix=+dfsg,dversionmangle=auto,filenamemangle=s/(?:.*?)?v?(\d[\d.]*)\.tar\.gz/kmc_$1.tar.gz/" \
	https://github.com/marekkokot/KMC/tags \
	(?:.*?/)?v?(\d[\d.]*)\.tar\.gz debian uupdate
